//Shadow's Battle Ability by SMS Alfredo

//Thinker for the Burst FX
local burstthinker = function(mobj)
	if mobj and mobj.valid and mobj.target and mobj.target.valid
		mobj.tracer = mobj.target
		mobj.flags2 = $&~MF2_DONTDRAW
		if mobj.target.health and mobj.target.skin == "shadow"
		and mobj.target.player and mobj.target.player.actionstate
			mobj.momx = 0 mobj.momy = 0 mobj.momz = 0
			if mobj.target.eflags&MFE_VERTICALFLIP
				mobj.eflags = $|MFE_VERTICALFLIP
				P_TeleportMove(mobj, mobj.target.x, mobj.target.y, mobj.target.z+mobj.target.height)
			else
				P_TeleportMove(mobj, mobj.target.x, mobj.target.y, mobj.target.z)
			end
		else
			P_KillMobj(mobj)
		end
	end
end
addHook("MobjThinker", burstthinker, MT_CHAOSBURST1)
addHook("MobjThinker", burstthinker, MT_CHAOSBURST2)
addHook("MobjThinker", burstthinker, MT_CHAOSBURST3)

//Thinker for the Nightmare FX
addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid and mobj.target and mobj.target.valid
		mobj.tracer = mobj.target
		mobj.flags2 = $&~MF2_DONTDRAW
		local angle = mobj.target.player.drawangle+ANGLE_90
		if mobj.flags2&MF2_AMBUSH then angle = $+ANGLE_180 end
		if mobj.target.health and mobj.target.skin == "shadow"
		and mobj.target.player and mobj.target.player.actionstate
			mobj.momx = 0 mobj.momy = 0 mobj.momz = 0
			if mobj.target.eflags&MFE_VERTICALFLIP
				mobj.eflags = $|MFE_VERTICALFLIP
				P_TeleportMove(mobj, P_ReturnThrustX(nil, angle, mobj.target.radius*3/2)+mobj.target.x,
				P_ReturnThrustY(nil, angle, mobj.target.radius*3/2)+mobj.target.y,
				mobj.target.z+mobj.target.height)
			else
				P_TeleportMove(mobj, P_ReturnThrustX(nil, angle, mobj.target.radius*3/2)+mobj.target.x,
				P_ReturnThrustY(nil, angle, mobj.target.radius*3/2)+mobj.target.y,
				mobj.target.z)
			end
		else
			P_KillMobj(mobj)
		end
	end
end, MT_CHAOSNIGHTMARE)

//For damaging in single player
addHook("PlayerCanDamage", function(player)
	if player.actionstate and player.actiontime
	and player.actiontime > 7 //and player.actiontime < TICRATE+7-4
		return true
	end
end)

freeslot("SKINCOLOR_SHADOWGLOW")

//The colors relating to the burst frames
local burstcolors = {
	SKINCOLOR_BLUEBELL,
	SKINCOLOR_BLUEBELL,
	SKINCOLOR_SHADOWGLOW,
	SKINCOLOR_ROSY,
	SKINCOLOR_SHADOWGLOW,
	SKINCOLOR_BLUEBELL,
	SKINCOLOR_SHADOWGLOW,
	SKINCOLOR_ROSY,
	SKINCOLOR_BLUEBELL,
	SKINCOLOR_ROSY
}

//Loading code from Krabs
local ScriptLoaded = false

addHook("ThinkFrame",function() if not(ScriptLoaded) and CBW_Battle 
	ScriptLoaded = true
	local B = CBW_Battle
	
	//Allow Shadow himself to deal damage
	//Note how he has zero defense, which makes him vurnerable to projectiles
	local ShadowPriority = function(player)
		if player.actionstate and player.actiontime
		and player.actiontime > 7 //and player.actiontime < TICRATE+7-4
			if player.actionstate > 1
				B.SetPriority(player,20,0,nil,20,0,"Chaos Nightmare")
			else
				B.SetPriority(player,20,0,nil,20,0,"Chaos Burst")
			end
		end
	end
	
	local ShadowSpecial = function(mo,doaction,pressedaction)
		local player = mo.player

		if P_IsObjectOnGround(mo)
			player.actiontext = "Chaos Burst"
			player.actionrings = 10
		else
			player.actiontext = "Chaos Nightmare"
			player.actionrings = 10
		end
		player.action2text = nil
		
		//Start the move
		if player.actionstate == 0
			if doaction == 1 and not player.homing
			and not (player.shadow.flags&~(1 << 2)) //SHF_SHIELDABILITY
			and not player.shadow.bike
				if P_IsObjectOnGround(mo)
					player.actionstate = 1
					S_StartSound(mo, sfx_chbrst)
					P_SpawnPlayerMissile(mo, MT_CHAOSBURST1, MF2_LINKDRAW|MF2_DONTDRAW)
					player.shadowsdumbburst = P_SpawnPlayerMissile(mo, MT_CHAOSBURST2, MF2_LINKDRAW|MF2_DONTDRAW)
					P_SpawnPlayerMissile(mo, MT_CHAOSBURST3, MF2_LINKDRAW|MF2_DONTDRAW)
				else
					mo.momz = 0
					player.actionstate = 2
					S_StartSound(mo, sfx_chnght)
				end
				player.canguard = false
				player.pflags = $|PF_FULLSTASIS&~PF_JUMPED
				player.actiontime = TICRATE+7
				B.PayRings(player)
				B.ApplyCooldown(player,TICRATE*2)
			end
			
		//End the move
		elseif not player.actiontime or P_PlayerInPain(player)
		or not player.actionallowed or player.shadow.bike
		or (player.shadow.flags&~(1 << 2)) //SHF_SHIELDABILITY
			if P_PlayerInPain(player)
				//nothing
			elseif P_IsObjectOnGround(mo)
				mo.state = S_PLAY_STND
			else
				mo.state = S_PLAY_FALL
				player.pflags = $|PF_THOKKED
				player.shadow.flags = $ | (1 << 2) //SHF_SHIELDABILITY
			end
			player.actionstate = 0
			mo.color = player.skincolor
			player.shieldscale = skins[mo.skin].shieldscale
			
		//Do the move
		elseif player.actionstate
			local maxdist = FixedMul(RING_DIST/6, mo.scale) //Attack range
			
			if mo.frame&FF_FRAMEMASK >= 2 and mo.tics != -1
				mo.tics = -1
			end
			
			//Nightmare
			if player.actionstate > 1
				maxdist = $*4/5 //Nightmare has a smaller range than Burst
				mo.momz = 0
				mo.momx = FixedMul($, FRACUNIT*97/100)
				mo.momy = FixedMul($, FRACUNIT*97/100)
				if mo.state != S_SHADOW_CHAOSNIGHTMARE
					mo.state = S_SHADOW_CHAOSNIGHTMARE
				end
				if mo.frame&FF_FRAMEMASK == 1 and mo.tics > 2
					mo.tics = 2
				end
				if player.actiontime == TICRATE+3
					P_SpawnPlayerMissile(mo, MT_CHAOSNIGHTMARE, MF2_LINKDRAW|MF2_DONTDRAW)
					P_SpawnPlayerMissile(mo, MT_CHAOSNIGHTMARE, MF2_AMBUSH|MF2_LINKDRAW|MF2_DONTDRAW)
				end
				
			//Burst
			else
				if mo.state != S_SHADOW_CHAOSBURST
					mo.state = S_SHADOW_CHAOSBURST
				end
				if player.shadowsdumbburst and player.shadowsdumbburst.valid
				and (mo.frame&FF_FRAMEMASK == 1 or mo.frame&FF_FRAMEMASK == 2)
					if burstcolors[player.shadowsdumbburst.frame&FF_FRAMEMASK]
						mo.color = burstcolors[player.shadowsdumbburst.frame&FF_FRAMEMASK]
					else
						mo.color = player.skincolor
						mo.frame = $+1
					end
				end
			end
			
			//Shrink your shield
			if player.actiontime > TICRATE+4
				player.shieldscale = $*2/3
			elseif player.actiontime == TICRATE+4
				player.shieldscale = 0
			end
			
			//Damage from afar
			if player.actiontime > 7 //and player.actiontime < TICRATE+7-4
				local thokmobj = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
				thokmobj.radius = maxdist

				searchBlockmap("objects", function(refmobj, foundmobj)
					if foundmobj.flags & MF_NOCLIPTHING or foundmobj.health <= 0
					or foundmobj == mo or foundmobj.flags2 & MF2_FRET or not P_CheckSight(mo, foundmobj)
					or ((twodlevel or mo.flags2 & MF2_TWOD) and abs(mo.y-foundmobj.y) > mo.radius)
					return end

					if foundmobj.player
						if foundmobj.player.spectator or foundmobj.player.panim == PA_PAIN or G_TagGametype()
						or foundmobj.player.powers[pw_invulnerability]
						or foundmobj.player.powers[pw_super]
						or foundmobj.player.powers[pw_flashing]
							return
						end
					elseif (!((foundmobj.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) and (foundmobj.flags & MF_SHOOTABLE))) == !(foundmobj.flags2 & MF2_INVERTAIMABLE))
						return // not a valid target
					end
		
					local zdist = (mo.z + mo.height/2) - (foundmobj.z + foundmobj.height/2)
					local dist = P_AproxDistance(mo.x-foundmobj.x, mo.y-foundmobj.y)

					dist = P_AproxDistance(dist, zdist)
					if dist > maxdist
						return // out of range
					end
						
					mo.flags2 = $|MF2_EXPLOSION //Increase knockback
					P_DamageMobj(foundmobj,mo,mo)
					mo.flags2 = $&~MF2_EXPLOSION
				end, thokmobj)
	
				P_KillMobj(thokmobj)
			
			//Grow your shield back
			elseif player.shieldscale < skins[mo.skin].shieldscale
				player.shieldscale = $+(skins[mo.skin].shieldscale/7)
			elseif player.shieldscale > skins[mo.skin].shieldscale
				player.shieldscale = skins[mo.skin].shieldscale
			end
			
			player.canguard = false
			player.pflags = $|PF_FULLSTASIS&~PF_JUMPED
			player.actiontime = $-1
		end
	end
	
	//We're gonna hijack the function that's used right after our weight is set
	//in order to make Shadow have less weight when using the homing attack
	//I'd love to just modify SkinVars, but we can't do that since it's global
	B.GotFlagStats = function(player)
		local skin = skins[player.mo.skin]
		if player.mo.skin == "shadow"
			if player.nerfedhoming
				player.mo.weight = FRACUNIT*70/100
			else
				player.mo.weight = FRACUNIT*90/100
			end
		end
		//Register debuff
		if (player.gotflag or player.gotcrystal) and player.gotflagdebuff == false then
			player.gotflagdebuff = true
		end
		//Unregister debuff and apply normal stats
		if not(player.gotflag or player.gotcrystal) and player.gotflagdebuff == true then
			player.gotflagdebuff = false
			player.normalspeed = skin.normalspeed
			player.acceleration = skin.acceleration
		end
		//Apply debuff
		if player.gotflagdebuff
			player.normalspeed = skin.normalspeed*9/10
			player.acceleration = skin.acceleration*4/5
			player.dashmode = 0
	-- 		if player.pflags&PF_JUMPED then
	-- 			player.pflags = $|PF_THOKKED
	-- 		end
		end
	end
	
	B.SkinVars["shadow"] = {
		weight = 90,
		special = ShadowSpecial,
		func_priority_ext = ShadowPriority,
	}
	
	print("Shadow's Battle Mod ability was loaded!")
end end)